StyleParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
StyleParser Class Referencefinal

the main class to read a Style file More...

`#include <StyleParser.hxx>`

Inheritance diagram for StyleParser:

## Public Member Functions
| StyleParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~StyleParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
virtual void | parse (librevenge::RVNGTextInterface *documentInterface)=0
| virtual function used to parse the input
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
virtual bool | checkHeader (MWAWHeader *header, bool strict=false)=0
| virtual function used to check if the document header is correct (or not)
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
void | newPage (int number)
| adds a new page
bool | createZones ()
| finds the different objects zones
bool | readTypeEntryMap ()
| tries to read the main entry map
bool | readBackgroundColor (MWAWEntry const &entry)
| tries to read the background color: bgcl
bool | readFormats (MWAWEntry const &entry)
| tries to read the format: cfor (v1.9)
bool | readExtraProperties (MWAWEntry const &entry)
| tries to read the extra property zone: xprc
bool | readFontNames (MWAWEntry const &entry)
| tries to read the font table: fntb (v1.6)
bool | readFontCorr (MWAWEntry const &entry)
| tries to read the font correspondance zone: font, contains the font id, the position in fntb and many unknown datas (v1.6).
bool | readStyleTable (MWAWEntry const &entry)
| tries to read the style zone: styl
bool | readMargins (MWAWEntry const &entry)
| tries to read the margins zone: marg
bool | readPrintInfo (MWAWEntry const &entry)
| tries to read the printer info zone: prec
bool | readPLCs (MWAWEntry const &entry, bool para)
| tries to read the plc zone: runa or para
bool | readPictures (MWAWEntry const &entry)
| tries to read the pictures zone: soup
bool | readRules (MWAWEntry const &entry)
| tries to read the rule zone: rule
bool | readStat (MWAWEntry const &entry)
| tries to read the stat zone: stat
bool | readTabWidth (MWAWEntry const &entry)
| tries to read the tab width zone : tabw
bool | readVersion (MWAWEntry const &entry)
| tries to read the version zone: vers
int | computeNumPages (MWAWEntry const &entry, bool unicodeChar) const
| compute the number of page of a zone
bool | sendText (MWAWEntry const &entry, bool unicodeChar)
| try to send the main text
bool | sendPicture (StyleParserInternal::Picture const &pict)
| try to send a picture knowing the char position
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< StyleParserInternal::State > | m_state
| the state

## Detailed Description

the main class to read a Style file

## Constructor & Destructor Documentation

## ◆ StyleParser()

StyleParser::StyleParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~StyleParser()

StyleParser::~StyleParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool StyleParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ computeNumPages()

int StyleParser::computeNumPages | ( | MWAWEntry const & | entry,
|  | bool | unicodeChar
| ) |  | const
| protected

compute the number of page of a zone

Referenced by createDocument().

## ◆ createDocument()

void StyleParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool StyleParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ newPage()

void StyleParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendText().

## ◆ parse()

void StyleParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readBackgroundColor()

bool StyleParser::readBackgroundColor | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the background color: bgcl

Referenced by createZones().

## ◆ readExtraProperties()

bool StyleParser::readExtraProperties | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the extra property zone: xprc

Referenced by createZones().

## ◆ readFontCorr()

bool StyleParser::readFontCorr | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the font correspondance zone: font, contains the font id, the position in fntb and many unknown datas (v1.6).

Referenced by createZones().

## ◆ readFontNames()

bool StyleParser::readFontNames | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the font table: fntb (v1.6)

Referenced by createZones().

## ◆ readFormats()

bool StyleParser::readFormats | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the format: cfor (v1.9)

Referenced by createZones().

## ◆ readMargins()

bool StyleParser::readMargins | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the margins zone: marg

Referenced by createZones().

## ◆ readPictures()

bool StyleParser::readPictures | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the pictures zone: soup

Referenced by createZones().

## ◆ readPLCs()

bool StyleParser::readPLCs | ( | MWAWEntry const & | entry,
|  | bool | para
| ) |  |
| protected

tries to read the plc zone: runa or para

Referenced by createZones().

## ◆ readPrintInfo()

bool StyleParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the printer info zone: prec

Referenced by createZones().

## ◆ readRules()

bool StyleParser::readRules | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the rule zone: rule

Referenced by createZones().

## ◆ readStat()

bool StyleParser::readStat | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the stat zone: stat

Referenced by createZones().

## ◆ readStyleTable()

bool StyleParser::readStyleTable | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the style zone: styl

Referenced by createZones().

## ◆ readTabWidth()

bool StyleParser::readTabWidth | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the tab width zone : tabw

Referenced by createZones().

## ◆ readTypeEntryMap()

bool StyleParser::readTypeEntryMap | ( |  | ) |
| protected

tries to read the main entry map

Referenced by checkHeader(), and createZones().

## ◆ readVersion()

bool StyleParser::readVersion | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the version zone: vers

Referenced by createZones().

## ◆ sendPicture()

bool StyleParser::sendPicture | ( | StyleParserInternal::Picture const & | pict | ) |
| protected

try to send a picture knowing the char position

Referenced by sendText().

## ◆ sendText()

bool StyleParser::sendText | ( | MWAWEntry const & | entry,
|  | bool | unicodeChar
| ) |  |
| protected

try to send the main text

Referenced by parse().

## Member Data Documentation

## ◆ m_state

std::shared_ptr<StyleParserInternal::State> StyleParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), newPage(), parse(), readBackgroundColor(), readFontNames(), readFormats(), readPictures(), readPLCs(), readRules(), readStyleTable(), readTypeEntryMap(), and sendText().

The documentation for this class was generated from the following files:

- StyleParser.hxx
- StyleParser.cxx